#!/usr/bin/perl -w

sub parseTime {
  #print "Parsing time @_";
  #die;
  my $timeStr = $_[0];
  @timeArray = split(":", $timeStr);
  #print STDERR @timeArray, "\n";
  return ($timeArray[0] + $timeArray[1]/60.0);
}

@inputfiles = glob("???.conf");

while ($infile = shift(@inputfiles)) {
  open (CONF, $infile) or die "Unable to open input configuration file";
  ($outname = $infile) =~ s/conf/xml/;
  print "Writing to $outname\n";
  open XMLFILE, ">$outname";
  while ($buf = readline(CONF)) {
    push @DataList, $buf;
  }
  close (CONF);
  print XMLFILE "<?xml version=\"1.0\"?>\n";
  print XMLFILE "<trafficlist>\n";
  while ($dataline = shift(@DataList)) {
    # print STDERR "Dataline: $dataline\n";
    @token = split(" ", $dataline);
    if (scalar(@token) > 0) {
      # print STDERR "Token: @token\n";
      if ($token[0] eq "AC") {
        print XMLFILE "  <aircraft>\n";
        print XMLFILE "    <model>$token[12]</model>\n";
        print XMLFILE "    <livery>$token[6]</livery>\n";
        print XMLFILE "    <airline>$token[5]</airline>\n";
        print XMLFILE "    <home-port>$token[1]</home-port>\n";
        print XMLFILE "    <required-aircraft>$token[3]$token[5]</required-aircraft>\n";
        print XMLFILE "    <actype>$token[4]</actype>\n";
        print XMLFILE "    <offset>$token[7]</offset>\n";
        print XMLFILE "    <radius>$token[8]</radius>\n";
        print XMLFILE "    <flighttype>$token[9]</flighttype>\n";
        print XMLFILE "    <performance-class>$token[10]</performance-class>\n";
        print XMLFILE "    <registration>$token[2]</registration>\n";
        print XMLFILE "    <heavy>$token[11]</heavy>\n";
        print XMLFILE "  </aircraft>\n";
      }
      if ($token[0] eq "FLIGHT") {
        $weekdays = $token[3];
        if ($weekdays =~ /^(0|\.){1}(1|\.){1}(2|\.){1}(3|\.){1}(4|\.){1}(5|\.){1}(6|\.){1}$/) {
          @day = split(//, $weekdays);
          foreach (@day) {
            # print STDERR "Day: $_\n";
            if ($_ eq ".") { next; }
            if ($token[4] !~ /^(([0-1]?[0-9])|([2][0-3])):([0-5]?[0-9])$/) {
              die "Error! Check your departure times! $token[4]\n"
            }
            if ($token[6] !~ /^(([0-1]?[0-9])|([2][0-3])):([0-5]?[0-9])$/) {
              die "Error! Check your arrival times! $token[6]\n"
            }
            $depTime = parseTime($token[4]);
            $arrTime = parseTime($token[6]);
            $depDay = $_;
            $arrDay = $depDay;
            if ($depTime > $arrTime) { $arrDay++ };
            if ($arrDay > 6) { $arrDay = 0 };
            print XMLFILE "  <flight>\n";
            print XMLFILE "    <callsign>$token[1]</callsign>\n";
            print XMLFILE "    <required-aircraft>$token[9]</required-aircraft>\n";
            print XMLFILE "    <fltrules>$token[2]</fltrules>\n";
            print XMLFILE "    <departure>\n";
            print XMLFILE "      <port>$token[5]</port>\n";
            print XMLFILE "      <time>$depDay/$token[4]:00</time>\n";
            print XMLFILE "    </departure>\n";
            print XMLFILE "    <cruise-alt>$token[8]</cruise-alt>\n";
            print XMLFILE "    <arrival>\n";
            print XMLFILE "      <port>$token[7]</port>\n";
            print XMLFILE "      <time>$arrDay/$token[6]:00</time>\n";
            print XMLFILE "    </arrival>\n";
            print XMLFILE "    <repeat>WEEK</repeat>\n";
            print XMLFILE "  </flight>\n";
          }
        } elsif ($weekdays eq "DAILY") {
          # print STDERR  "Weekdays = $weekdays\n";
          print XMLFILE "  <flight>\n";
          print XMLFILE "    <callsign>$token[1]</callsign>\n";
          print XMLFILE "    <required-aircraft>$token[9]</required-aircraft>\n";
          print XMLFILE "    <fltrules>$token[2]</fltrules>\n";
          print XMLFILE "    <departure>\n";
          print XMLFILE "      <port>$token[5]</port>\n";
          print XMLFILE "      <time>$token[4]:00</time>\n";
          print XMLFILE "    </departure>\n";
          print XMLFILE "    <cruise-alt>$token[8]</cruise-alt>\n";
          print XMLFILE "    <arrival>\n";
          print XMLFILE "      <port>$token[7]</port>\n";
          print XMLFILE "      <time>$token[6]:00</time>\n";
          print XMLFILE "    </arrival>\n";
          print XMLFILE "    <repeat>24Hr</repeat>\n";
          print XMLFILE "  </flight>\n";
        } elsif (!($weekdays =~ /^(0|\.){1}(1|\.){1}(2|\.){1}(3|\.){1}(4|\.){1}(5|\.){1}(6|\.){1}$/) || ($weekdays eq "DAILY")) {
            die "Error! Check your days! $weekdays\n";
        }
        else {
          die "Error! Reading configuration file!\n";
        }
      }
    }
  }
  print XMLFILE "</trafficlist>\n";
  close XMLFILE;
}
